// generated from rosidl_generator_c/resource/msg__functions.h.em
// generated code does not contain a copyright notice

#ifndef ETS_MSGS__MSG__TRUCK__FUNCTIONS_H_
#define ETS_MSGS__MSG__TRUCK__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "ets_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "ets_msgs/msg/truck__struct.h"

/// Initialize ets_msgs/Truck message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(ets_msgs__msg__Truck)) before
 * or use ets_msgs__msg__Truck__create() to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
bool
ets_msgs__msg__Truck__init(ets_msgs__msg__Truck * msg);

/// Finalize ets_msgs/Truck message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
void
ets_msgs__msg__Truck__fini(ets_msgs__msg__Truck * msg);

/// Create ets_msgs/Truck message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls ets_msgs__msg__Truck__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
ets_msgs__msg__Truck *
ets_msgs__msg__Truck__create();

/// Destroy ets_msgs/Truck message.
/**
 * It calls ets_msgs__msg__Truck__fini() and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
void
ets_msgs__msg__Truck__destroy(ets_msgs__msg__Truck * msg);


/// Initialize array of ets_msgs/Truck messages.
/**
 * It allocates the memory for the number of elements and
 * calls ets_msgs__msg__Truck__init() for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
bool
ets_msgs__msg__Truck__Sequence__init(ets_msgs__msg__Truck__Sequence * array, size_t size);

/// Finalize array of ets_msgs/Truck messages.
/**
 * It calls ets_msgs__msg__Truck__fini() for each element of the array and
 * frees the memory for the number of elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
void
ets_msgs__msg__Truck__Sequence__fini(ets_msgs__msg__Truck__Sequence * array);

/// Create array of ets_msgs/Truck messages.
/**
 * It allocates the memory for the array and
 * calls ets_msgs__msg__Truck__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
ets_msgs__msg__Truck__Sequence *
ets_msgs__msg__Truck__Sequence__create(size_t size);

/// Destroy array of ets_msgs/Truck messages.
/**
 * It calls ets_msgs__msg__Truck__Sequence__fini() on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_ets_msgs
void
ets_msgs__msg__Truck__Sequence__destroy(ets_msgs__msg__Truck__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ETS_MSGS__MSG__TRUCK__FUNCTIONS_H_
