// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef ETS_MSGS__MSG__TRUCK__STRUCT_HPP_
#define ETS_MSGS__MSG__TRUCK__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_ets_msgs_msg_Truck __attribute__((deprecated))
#else
# define DEPRECATED_ets_msgs_msg_Truck __declspec(deprecated)
#endif

namespace ets_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Truck_
{
  using Type = Truck_<ContainerAllocator>;

  explicit Truck_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed = 0.0;
      this->acc_x = 0.0;
      this->acc_y = 0.0;
      this->acc_z = 0.0;
      this->rpm = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gear = 0l;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->engine_running = false;
      this->trailer_connected = false;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
      this->heading = 0.0;
      this->pitch = 0.0;
      this->roll = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->parking_brake = false;
    }
  }

  explicit Truck_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->speed = 0.0;
      this->acc_x = 0.0;
      this->acc_y = 0.0;
      this->acc_z = 0.0;
      this->rpm = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gear = 0l;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->engine_running = false;
      this->trailer_connected = false;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->x = 0.0;
      this->y = 0.0;
      this->z = 0.0;
      this->heading = 0.0;
      this->pitch = 0.0;
      this->roll = 0.0;
    }
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->parking_brake = false;
    }
  }

  // field types and members
  using _speed_type =
    double;
  _speed_type speed;
  using _acc_x_type =
    double;
  _acc_x_type acc_x;
  using _acc_y_type =
    double;
  _acc_y_type acc_y;
  using _acc_z_type =
    double;
  _acc_z_type acc_z;
  using _rpm_type =
    double;
  _rpm_type rpm;
  using _gear_type =
    int32_t;
  _gear_type gear;
  using _engine_running_type =
    bool;
  _engine_running_type engine_running;
  using _trailer_connected_type =
    bool;
  _trailer_connected_type trailer_connected;
  using _x_type =
    double;
  _x_type x;
  using _y_type =
    double;
  _y_type y;
  using _z_type =
    double;
  _z_type z;
  using _heading_type =
    double;
  _heading_type heading;
  using _pitch_type =
    double;
  _pitch_type pitch;
  using _roll_type =
    double;
  _roll_type roll;
  using _parking_brake_type =
    bool;
  _parking_brake_type parking_brake;

  // setters for named parameter idiom
  Type * set__speed(
    const double & _arg)
  {
    this->speed = _arg;
    return this;
  }
  Type * set__acc_x(
    const double & _arg)
  {
    this->acc_x = _arg;
    return this;
  }
  Type * set__acc_y(
    const double & _arg)
  {
    this->acc_y = _arg;
    return this;
  }
  Type * set__acc_z(
    const double & _arg)
  {
    this->acc_z = _arg;
    return this;
  }
  Type * set__rpm(
    const double & _arg)
  {
    this->rpm = _arg;
    return this;
  }
  Type * set__gear(
    const int32_t & _arg)
  {
    this->gear = _arg;
    return this;
  }
  Type * set__engine_running(
    const bool & _arg)
  {
    this->engine_running = _arg;
    return this;
  }
  Type * set__trailer_connected(
    const bool & _arg)
  {
    this->trailer_connected = _arg;
    return this;
  }
  Type * set__x(
    const double & _arg)
  {
    this->x = _arg;
    return this;
  }
  Type * set__y(
    const double & _arg)
  {
    this->y = _arg;
    return this;
  }
  Type * set__z(
    const double & _arg)
  {
    this->z = _arg;
    return this;
  }
  Type * set__heading(
    const double & _arg)
  {
    this->heading = _arg;
    return this;
  }
  Type * set__pitch(
    const double & _arg)
  {
    this->pitch = _arg;
    return this;
  }
  Type * set__roll(
    const double & _arg)
  {
    this->roll = _arg;
    return this;
  }
  Type * set__parking_brake(
    const bool & _arg)
  {
    this->parking_brake = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ets_msgs::msg::Truck_<ContainerAllocator> *;
  using ConstRawPtr =
    const ets_msgs::msg::Truck_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ets_msgs::msg::Truck_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ets_msgs::msg::Truck_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ets_msgs::msg::Truck_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ets_msgs::msg::Truck_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ets_msgs::msg::Truck_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ets_msgs::msg::Truck_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ets_msgs::msg::Truck_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ets_msgs::msg::Truck_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_ets_msgs_msg_Truck
    std::shared_ptr<ets_msgs::msg::Truck_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_ets_msgs_msg_Truck
    std::shared_ptr<ets_msgs::msg::Truck_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Truck_ & other) const
  {
    if (this->speed != other.speed) {
      return false;
    }
    if (this->acc_x != other.acc_x) {
      return false;
    }
    if (this->acc_y != other.acc_y) {
      return false;
    }
    if (this->acc_z != other.acc_z) {
      return false;
    }
    if (this->rpm != other.rpm) {
      return false;
    }
    if (this->gear != other.gear) {
      return false;
    }
    if (this->engine_running != other.engine_running) {
      return false;
    }
    if (this->trailer_connected != other.trailer_connected) {
      return false;
    }
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->pitch != other.pitch) {
      return false;
    }
    if (this->roll != other.roll) {
      return false;
    }
    if (this->parking_brake != other.parking_brake) {
      return false;
    }
    return true;
  }
  bool operator!=(const Truck_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Truck_

// alias to use template instance with default allocator
using Truck =
  ets_msgs::msg::Truck_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ets_msgs

#endif  // ETS_MSGS__MSG__TRUCK__STRUCT_HPP_
